unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MyFunc, JwwGaibu, StdCtrls ;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    AppPath : string ;
    px,py : double ;
    col,ltp,wid : integer ;
    procedure OpenDatFile ;
    procedure SaveDatFile ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile ;
var
   fn: string ;
   F : TextFile ;
   s : string ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   px := 0.0;
   py := 0.0;
   col:= 0;
   ltp:= 0;
   wid:=-1;
   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, s);  px := SDbl(s);
      ReadLn(F, s);  py := SDbl(s);
      ReadLn(F, s);  col:= SInt(s);
      ReadLn(F, s);  ltp:= SInt(s);
      ReadLn(F, s);  wid:= SInt(s);

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile ;
var
   fn: string ;
   F : TextFile ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, FloatToStr(px));
      WriteLn(F, FloatToStr(py));
      WriteLn(F, IntToStr(col));
      WriteLn(F, IntToStr(ltp));
      WriteLn(F, IntToStr(wid));

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then
         DeleteFile(fn);
   end;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
var
   i : integer ;
begin
   if (ParamCount >= 1) then
      Form1.WindowState := wsMinimized ;
   // ݒ
   InitJwwGaibu ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // JWC_TEMP.TXTJ܂
   OpenTempFile(AppPath+'JWC_TEMP.TXT') ;
   //
   OpenDatFile ;
   if (ParamCount >= 1) then begin
      S_Col(col,1);  // F
      S_Ltp(ltp,1);  // 
      S_Wid(wid);    // 
      //
      if (ParamStr(1) = '/R0') then begin
         S_Line(JG_IPoints[1].x , JG_IPoints[1].y,
                JG_IPoints[2].x , JG_IPoints[2].y );
         px := JG_IPoints[2].x ;
         py := JG_IPoints[2].y ;
      end
      else if (ParamStr(1) = '/R1') then begin
         for i:=1 to 98 do begin
            if not(JG_IPoints[i+1].flg) then break;
            S_Line(JG_IPoints[i  ].x , JG_IPoints[i  ].y,
                   JG_IPoints[i+1].x , JG_IPoints[i+1].y );
            px := JG_IPoints[i+1].x ;
            py := JG_IPoints[i+1].y ;
         end;
      end
      else if (ParamStr(1) = '/R2') then begin
         S_Line(px,py, JG_IPoints[1].x , JG_IPoints[1].y);
         px := JG_IPoints[1].x ;
         py := JG_IPoints[1].y ;
      end;
      SaveDatFile ;
      Close ;
   end
   else begin
      // ݒ
      Form1.Left := Mouse.CursorPos.X - Form1.Width  div 2;
      Form1.Top  := Mouse.CursorPos.Y - Form1.Height div 2;
      //
      ComboBox1.Items.Clear ;
      ComboBox1.Items.Add('ݐF');
      for i:=1 to 9 do
         ComboBox1.Items.Add('F'+IntToStr(i));
      for i:=1 to 256 do
         ComboBox1.Items.Add('SXF-'+IntToStr(i));
      ComboBox2.Items.Clear ;
      ComboBox2.Items.Add('ݐ');
      for i:=1 to 9 do
         ComboBox2.Items.Add(''+IntToStr(i));
      for i:=1 to 5 do
         ComboBox2.Items.Add('_'+IntToStr(i));
      for i:=1 to 4 do
         ComboBox2.Items.Add('{'+IntToStr(i));
      for i:=1 to 32 do
         ComboBox2.Items.Add('SXF-'+IntToStr(i));
      ComboBox3.Text := '' ;
      //
      ComboBox1.ItemIndex := col ;
      ComboBox2.ItemIndex := ltp ;
      if (wid >= 0) then
         ComboBox3.Text := IntToStr(wid);
   end;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if (ParamCount >= 1) then begin
      // JWC_TEMP.TXTۑ܂
      SaveTempFile(AppPath+'JWC_TEMP.TXT') ;
   end;
   // ŏI
   EndJwwGaibu ;
end;

// [OK]
procedure TForm1.Button1Click(Sender: TObject);
begin
   col := ComboBox1.ItemIndex ;
   ltp := ComboBox2.ItemIndex ;
   if (ComboBox3.Text = '') then
      wid := -1
   else
      wid := SInt(ComboBox3.Text);
   SaveDatFile ;
   Close ;
end;

// [Cancel]
procedure TForm1.Button2Click(Sender: TObject);
begin
   Close ;
end;

end.
 